package dev.micle.totemofreviving.network;

import dev.micle.totemofreviving.TotemOfReviving;
import dev.micle.totemofreviving.network.client.ChangeTargetPacket;
import dev.micle.totemofreviving.network.client.ChargeTotemPacket;
import dev.micle.totemofreviving.network.client.ReviveTargetPacket;
import net.minecraftforge.network.NetworkRegistry;
import net.minecraftforge.network.simple.SimpleChannel;

public class NetworkManager {
	// Initialize variables
	private static SimpleChannel channel;
	
	public static void init() {
		// Create channel
		channel = NetworkRegistry.ChannelBuilder.named(TotemOfReviving.createResourceLocation("network"))
				.clientAcceptedVersions(v -> v.equals(TotemOfReviving.getVersion()))
				.serverAcceptedVersions(v -> v.equals(TotemOfReviving.getVersion()))
				.networkProtocolVersion(TotemOfReviving::getVersion)
				.simpleChannel();

		// Register packets
		int id = 0;
		channel.messageBuilder(ChangeTargetPacket.class, id++)
				.encoder(ChangeTargetPacket::encode)
				.decoder(ChangeTargetPacket::decode)
				.consumer(ChangeTargetPacket::handle)
				.add();
		channel.messageBuilder(ChargeTotemPacket.class, id++)
				.encoder(ChargeTotemPacket::encode)
				.decoder(ChargeTotemPacket::decode)
				.consumer(ChargeTotemPacket::handle)
				.add();
		channel.messageBuilder(ReviveTargetPacket.class, id++)
				.encoder(ReviveTargetPacket::encode)
				.decoder(ReviveTargetPacket::decode)
				.consumer(ReviveTargetPacket::handle)
				.add();
	}

	public static SimpleChannel getChannel() {
		return channel;
	}
}
